include "chat.iol"
include "console.iol"

execution { concurrent }

inputPort ChatInput {
Location: "socket://localhost:8000/"
Protocol: sodep
Interfaces: ChatInterface
}

outputPort Client {
Protocol: sodep
Interfaces: ClientInterface
}

cset {
roomName:
	OpenRoomRequest.roomName
	PublishRequest.roomName
	GetHistory.roomName
	EnterRoomRequest.roomName
}

define updateClients
{
	for( i = 0, i < #clients, i++ ) {
		Client.location = clients[i].location;
		update@Client( pubReq )
	}
}

main
{
	openRoom( openReq )( openResp ) {
		csets.roomName = openReq.roomName;
		println@Console(
			"Created room "
			+ openReq.roomName
			+ " by " + openReq.username
		)()
	};
	history = "";
	while( true ) {
		[ publish( pubReq )() {
			m = "[" + pubReq.roomName + "] "
				+ pubReq.username + ": "
				+ pubReq.message;
			println@Console( m )();
			history += m + "\n";
			updateClients
		} ] { nullProcess }

		[ getHistory()( history ) {
			nullProcess
		} ] { nullProcess }

		[ enterRoom( enterRoomReq )() {
			clients[#clients].location =
				enterRoomReq.location
		} ] {
			nullProcess
		}
	}
}